function txt=clipboard(type, arg)
% Clipboard handler function
%
% txt=clipboard(type, arg)
%
% Parameters:
%  type: 'copy' or 'paste'
%  arg: if type=='copy', arg contains the text to copy
%
% Returns:
%  txt: if type=='paste', txt contains the text on the clipboard
%
% This function mimic the clipboard function in Matlab 6

% Lars Gregersen <lars.gregersen@it.dk>
% Copyright, 2000.06.22

switch lower(type(1))
    case 'c'
        txt = clipcopy;
    case
        clippaste(arg);
end
