function [a,A]=clipextract(b,numheaders)
% Extract data from clipboard format (Excel)

if ~exist('numheaders','var')
    numheaders = 0;
end

if numheaders
    [a,r] = extract(b,numheaders)
    A = extractnum(r);
else
    a = extract(b);
end

% ---------------------------
function [a,r]=extract(b,numheaders)

if ~exist('numheaders','var') | numheaders==0
    numheaders = inf;
end

i = 1;
r = b;
while (any(r))
    [l,r] = strtok(r,10); % split on newlines
    rr = l(1:end-1);
    j = 1;
    while (any(rr))
        [e,rr] = strtok(rr,9); % split on tabs
        [n,count] = sscanf(e,'%g');
        if count==1
            e = n;
        end
        a{i,j} = e;
        j = j+1;
    end
    i = i+1;
    if i>numheaders
        break
    end
end

% ---------------------------
function [a,r]=extractnum(b,numheaders)

if ~exist('numheaders','var') | numheaders==0
    numheaders = inf;
end

i = 1;
r = b;
while (any(r))
    [l,r] = strtok(r,10); % split on newlines
    rr = l(1:end-1);
    j = 1;
    while (any(rr))
        [e,rr] = strtok(rr,9); % split on tabs
        [n,count] = sscanf(e,'%g');
        if count~=1
            error('Array not numeric')
        end
        a(i,j) = n;
        j = j+1;
    end
    i = i+1;
    if i>numheaders
        break
    end
end

