function excelclipcopy(A,c)
% excelclipcopy(A,c)
%
% copies a numeric matrix to the clipboard
% in a format that MS Excel can read.
%
% if c is 1 the numbers are exported with
% decimal points replaced by commas.
%
% excelclipcopy only works on the Windows platform
%
% See also: excelclippaste, clipcopy, clippaste

% Lars Gregersen
% Copyright, 1999
%
% 1999.11.03, version 1.0

% create pattern
pattern = '%f';
for i=1:size(A,2)-1
  pattern = [pattern 9 '%f'];
end
pattern = [pattern 13 10];

% create string
s = sprintf(pattern, A');

% replace decimal points with commas
if exist('c') & any(c)
  fdp = find(s=='.');
  s(fdp) = ',';
end

clipcopy(s)
