function out1 = jpsth(action, in1,in2);
% jpsth		- JPSTH analysis
%--------------------------------------------------------------------------------
% UNITRET MODULE
% Written by I.Kagan																					
% *******************************						
% * Last modification: 03.05.00 *						
% *******************************
% Short description:
% Joint Peristimulus Histogram
% General version
% Here Scatter Matrix is calculated analytically 
% (PST per sweep and Copy as should be changed in JPSTHS)
%--------------------------------------------------------------------------------

  if nargin<1,
      clear global;
      h=get(0,'Children');
      close(h);
      fclose('all');
      action='start';
      matlabpath = path;
      act_dir = cd;
      if isempty(findstr(lower(matlabpath),lower(act_dir))),
        path(matlabpath,act_dir);
      end;
  end;

  global jpsth_UI jpsth_UIF CELL1 CELL2 JPSTHist m Analysis DefValues figcounter npij Cij Dij sij ncij M Scatter cf ...
         v

  % v -version
  % GET VERSION
    v=version;

  % SET WARNING OFF
  if strcmp(v(1),'5'),
     eval('warning off')
  end
  
  % for MATLAB5 only: Analysis={'Scatter'  'Raw JPSTH'  'Pred JPSTH'  'Norm JPSTH'  'Coincidence Hist'  'CrossCor'  'AutoCorr'  'PSTH'  'ISI' 'Full Analysis' 'PSTH per sweep' 'Xcor' 'JPSTH:Dij' 'JPSTH:SDij' 'Xcor-Shift'};  
   Analysis=['Scatter         ';  'Raw JPSTH       ';  'Pred JPSTH      ';  'Norm JPSTH      ';  'Coincidence Hist';  'CrossCor        ';  'AutoCorr        ';  'PSTH            ';...
              'ISI             '; 'Full Analysis   '; 'PSTH per sweep  '; 'Xcor            '; 'JPSTH:Dij       '; 'JPSTH:SDij      '; 'Xcor-Shift      '];  
  DefValues = get(0,'UserData');


  if strcmp(action,'start'),
  
% Default values: - Stored in ROOT object (0) as a UserData

  BinSize  = 10; %1  Bin Size
  Xhist	   = 0;  %2  Promt when #events per bin per sweep > 1 
  Yhist    = 0;  %3  Show Crude with Smoothed
  Smooth   = 0;  %4  Smooth
  Colmap   = 1;  %5  Color Map
  ShiftPred= 0;  %6  Shift Predictor
  To=0;		 %7  To
  Tend=500;	 %8  Tend
  BasicM=[1];    %9  For opertaions on JPSTH Matrix 
  Norm=[1];      %10 Normalize for # of segments
  AnType=1; 	 %11 Analysis type
  NumParaBin=1;  %12 # of bins for CH
  BasicBin=1;    %13 usually 1 ms
  Sigma=1;       %14 for smoothing
  XCorBin=1;     %15 Bin for XCor in ms
  MaxLag=50;     %16 for XCor Max Delay in ms
 
  %------
  npij=[];
  Cij=[];
  
  % figcounter - how many analysises are made
  figcounter = 3; %(Fig. 1, Fig. 2, Fig. 3 (Parameters Setup))
    
   set(0,'UserData', [BinSize, Xhist, Yhist, Smooth, Colmap, ShiftPred, To, Tend, BasicM, Norm, AnType, NumParaBin, BasicBin, Sigma, XCorBin, MaxLag],'DefaultTextFontName','Helvetica',...
				 'DefaultFigureInvertHardcopy','off','DefaultTextFontSize',12, 'DefaultTextColor',...
				 'k','DefaultTextFontWeight','demi','DefaultFigureNumberTitle','off', ...
				 'DefaultFigurePaperType','a4letter','DefaultTextUnits','norm',...
				 'DefaultAxesUnits','norm','DefaultUIcontrolUnits','norm');
   

        
           Fig1 = figure('Backingstore','on','Color',[.5 .6 .7],'Units','normalized',...
     	    'Position',[0.002 0.05 .8 .88],'Resize','On', 'Name',...
            'JPSTH v.1.0','MenuBar','none','Number','off','Userdata',0);

    % for Sasha's comp:      
    %      Fig1 = figure('Backingstore','on','Color',[.5 .6 .7],'Units','normalized',...
    %	    'Position',[1 35 670 525],'Resize','On', 'Name',...
    %        'JPSTH v.1.0','MenuBar','none','Number','off','Userdata',0);
     
    % for Pentium Farm: 
    %   Fig1 = figure('Backingstore','on','Color',[.5 .6 .7],...
    %   'Position',[1 30 800 700],'Resize','On', 'Name',...
    %   'JPSTH v.1.0','MenuBar','none','Number','off','Userdata',0);

    % for Upper Pentium Farm: 
    %    Fig1 = figure('Backingstore','on','Color',[.5 .6 .7],...
    %  	 'Position',[1 30 640 440],'Resize','On', 'Name',...
    %    'JPSTH v.1.0','MenuBar','none','Number','off','Userdata',0);	

%%% UICONTROLS OF FIG1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
    
    c(1)=uicontrol(Fig1,'Style','frame','Units','normalized','Position',[.025 .825 .85 .15],...
	'BackgroundColor',[.7 .8 .9],'ForegroundColor','k');

    c(2) =  uicontrol(Fig1,'Style','text','Units','normalized','Position',[.1 .925 .7 .04],...
	'BackgroundColor',[.7 .8 .9],'ForegroundColor','r',...
	'HorizontalAlignment','center','String','CELLS');
	


     c(3) = uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 .875 .82 .04],...
	'BackgroundColor',[.7 .8 .9],'ForegroundColor','k',...
	'HorizontalAlignment','left','String','Cell 1');

     c(4) = uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 .83 .82 .04],...
	'BackgroundColor',[.7 .8 .9],'ForegroundColor','k',...
	'HorizontalAlignment','left','String','Cell 2');

      
    c(5)=uicontrol(Fig1,'Style','frame','Units','normalized','Position',[.025 .025 .95 .775],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor','w');


   InfoHndl=uicontrol(Fig1,'Style','pushbutton',...
   'position',[.1 .1 .12 .05],'string','Get Info','UserData',1,'callback','jpsth(''info'',1);');   

      
%%% MENU %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     % FILE MENU
     m(1) = uimenu(Fig1,'Label','&File');
     m(2) = uimenu(m(1),'Label','Open File &1','Callback','jpsth(''read_file'',1)','callback',...
     'global CELL1; CELL1 = jpsth(''read_file'',1);');
     m(3) = uimenu(m(1),'Label','Open File &2','Callback','global CELL2; CELL2 = jpsth(''read_file'',2);');
     m(8) = uimenu(m(1),'Label','Call &UNISPLIT','Callback','unisplit','Separator','on');
     m(9) = uimenu(m(1),'Label','Call &UNITRET','Callback','unitret');
     m(12) = uimenu(m(1),'Label','&Reload','Separator','on','Callback','global CELL1; CELL1 = jpsth(''read_file'',3);','enable','off');
     %%%$$$ reload does not work currently, + appearence of last files in FILE $$$
     m(13) = uimenu(m(1),'Label','S&wap Cells 1 and 2','Separator','On','Callback','jpsth(''read_file'',1)','callback',...
     'global CELL1; CELL1 = jpsth(''read_file'',1);');
     m(4) = uimenu(m(1),'Label','E&xit','Separator','on','Callback','jpsth(''exit'');');

     %-----------------------------------------------------------------------------------------------------
     m(5) = uimenu(Fig1,'Label','&Sim');
     m(6) = uimenu(m(5),'Label','Open Sim File &1','Callback','jpsth(''read_sim_file'',1)','callback',...
     'global CELL1; CELL1 = jpsth(''read_sim_file'',1);');
     m(7) = uimenu(m(5),'Label','Open Sim File &2','Callback','global CELL2; CELL2 = jpsth(''read_sim_file'',2);');
     
     %---------------------------------------------------------------- 
     m(10)= uimenu(Fig1,'Label','&Analysis');
     m(11)= uimenu(m(10),'Label','&New Analysis...','Callback','jpsth(''New Analysis'');');
     m(16)= uimenu(m(10),'Label','&Clear All','Callback','jpsth(''Clear'');');
     
     %------------------------------------------------------------------------------------
     m(13)= uimenu(Fig1,'Label','&Window');
     m(14)= uimenu(m(13),'Label','&Close all graphic windows');
     str=['t=sort(get(0,''children''));for h=t(2:length(t)),close(h);end;'];
     set(m(14),'Callback',str);
     m(15) = uimenu(m(13),'Label','&Reinitialize figs counter','Callback','global figcounter; figcounter=3;','Separator','on');
     %-----------------------------------------------------------------------------------------
     m(17) = uimenu(Fig1,'Label','&View');
     m(18) = uimenu(m(17),'Label','Zoom &In','Callback','set(0,''CurrentFigure'',get(gcf,''Userdata''));zoom(1.5);jpsth(''setsign'',''zoom on'');set(gcf,''Pointer'',''Arrow'');');
     m(19) = uimenu(m(17),'Label','Zoom &On','Callback','set(0,''CurrentFigure'',get(gcf,''Userdata''));zoom on;jpsth(''setsign'',''zoom on'');set(gcf,''Pointer'',''Arrow'');');
     m(20) = uimenu(m(17),'Label','Zoom O&ut','Callback','set(0,''CurrentFigure'',get(gcf,''Userdata''));zoom out;zoom off;jpsth(''setsign'',''zoom off'');set(gcf,''Pointer'',''Arrow'');');
     % m(21) = uimenu(m(17),'Label','&Show Crude with Smoothed','Separator','on','Callback','global crude; crude=1;');
 %-----------------------------------------------------------------------------------------

     Fig2 = 0;
     Fig3 = 0;
    %%% c=[]; %%% temp!!! %%% !!!
    jpsth_UI = [Fig1 Fig2 c, m, 0 0 0];
    jpsth_UIF= [Fig3 0];
    
    % ICON
    if strcmp(v(1),'5')

	    [icon,icmap]=imread('jpsth.ico','bmp');
	    colormap(icmap)
	    image(icon)
	    set(gca,'Position',[.905 .8866 .095 .1134 ],'visible','off')
	    fclose all;

    else % MATLAB 4
	    set(gca,'Position',[.905 .8866 .095 .1134 ],'visible','off','color','k')
            text(.1,.3,'JPSTH','Fontsize',11,'Color','r');
    end % of ICON

        
%--------------------------------------------------------------------------------------------------------------------------------------------------------------
   elseif(strcmp(action,'isfigure'))
     figs = get(0,'children');
     found=find(figs==in1);
     out1 = length(found);
     
%-----------------------------------------------------------------------------------------
   elseif(strcmp(action,'read_file'))
   clear global  JPSTHist npij Cij M Scatter sij;

%%% THIS BLOCK IS TAKEN FROM SASHA'S "...tret_new/jps.m"
   
   if in1==3 % RELOAD CELL1 (after shuffling)
      temp = get(jpsth_UI(1+4),'string');
      FullName = temp(9:length(temp));
      in1=1;
      filename=FullName;
  
   else
      if in1==2, % open second cell in pair
          strdlg = get(jpsth_UI(1+4),'string');
	  strdlg=[strdlg(9:length(strdlg)-4), '.s??'];
      else
          strdlg='*.s??';
      end
      [filename, pathname] = uigetfile(strdlg, ['Retrival of Spike Data (File ',num2str(in1),')'], .4, .4);
      if filename == 0, return; end;
      FullName = [pathname,filename];
      com = ['cd ' pathname(1:length(pathname)-1)]; 
      eval(com);
   end

   % WAIT SIGN
   SignHndl=uicontrol(jpsth_UI(1),'Style','text','Units','normalized','Position',[.9 .83 .1 0.03],...
	'BackgroundColor','r','ForegroundColor','y',...
        'HorizontalAlignment','center','String','WAIT');
   drawnow
   set(gcf,'Pointer','Watch')
   
   [fid,message] = fopen(FullName,'rb');
   if fid<0, 
       error(message);
   end;

  set(jpsth_UI(in1+4),'string',['Cell ',num2str(in1),': ',filename],'foregroundcolor','b');


  [F,lgn] = fread(fid,inf,'char');
  status = fseek(fid,0,-1);  % rewind the file
  ind=0;
  Spk = [];
  spikes=[];
  spikes_length=0;

  %%%%%%%%%%%%%%%%%%%%%%%%%%%% 
  % CELL... vector format:
  % in each row one segment:
  % #trial
  % #spikes
  % to
  % tend
  % modality
  % spikes arrival times 
  % ...
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%

  segnum=1;
  while(ind<lgn)
% spikes number, start stim and end stim reading...
	 vect=[];
	 vect(1:5) = fread(fid,5,'float');
         spikes(1:5)=vect(1:5);

% spikes arrival times reading...
	 vect(6:(vect(2)+5)) = fread(fid,vect(2),'float');
         	spikes(6:(vect(2)+5))=vect(6:(vect(2)+5));

% reading of the eye motion interval length , Stim Velocity inf and tilt.	 
	 EyeMotionLength=fread(fid,1,'float');
	 vect(vect(2)+6) = EyeMotionLength;
	 
	 tmp=3*EyeMotionLength+2;
	 
         vect((vect(2)+7):(vect(2)+8+3*EyeMotionLength))=fread(fid,tmp,'float');


	 ncol = size(Spk,2);
	 nrow = size(Spk,1);                %=TrialsNum of the given file
	 vlgn = length(vect);
        
	 maxncol = max((vlgn),ncol);
	 newrow = nrow + 1;
	 tmp = zeros(newrow,maxncol);
	 for i=1:nrow,
	   tmp(i,1:ncol) =Spk(i,:);
	 end;
	 tmp(newrow,1:vlgn) = vect;
         Spk = tmp;
	 ind=ftell(fid);
   end;
   fclose(fid);
   
   SegmentLength =  Spk(:,4) - Spk(:,3);
   if sum(diff(SegmentLength)),
      jpsth('errormessage','Segments of Different Lengths', 'Warning');
   end;       
  
    %  set(jpsth_UI(14),'String','0');
    %  set(jpsth_UI(17),'String',num2str(min(SegmentLength)));
      DefValues=get(0,'Userdata');
      DefValues(8)=min(SegmentLength);
      set(0,'Userdata',DefValues);
      
      
    % Files Info Info Info Info Info Info Info 
    
    Fig1=jpsth_UI(1);
      
    uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 0.8-in1/4 .2 .09],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor',[.4 .2 .15],...
   'HorizontalAlignment','left','String',['CELL',num2str(in1),':']);

	 uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 0.75-in1/4 .2 .09],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor',[.4 .2 .15],...
   'HorizontalAlignment','left','String',['events #: ',num2str(sum(Spk(:,2)))]);

    uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 0.70-in1/4 .2 .09],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor',[.4 .2 .15],...
   'HorizontalAlignment','left','String',['segments #: ',num2str(size(Spk,1))]);

    uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 0.65-in1/4 .3 .09],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor',[.4 .2 .15],...
   'HorizontalAlignment','left','String',['segments duration: ',num2str(sum(Spk(1,4)-Spk(1,3))),' ms']);

    
      out1 = Spk;       % -> to CELL...
      
      
  % READY SIGN
  set(SignHndl,'BackgroundColor','g','ForegroundColor',[.1 .1 .1],'String','READY'); 
  set(gcf,'Pointer','Arrow')
    
      
%-----------------------------------------------------------------------------------------


elseif(strcmp(action,'read_sim_file'))
   clear global JPSTHist npij Cij M Scatter sij;

  [sfilename, spathname] = uigetfile('*.sim', 'Retrival of Simulated Data', .4, .4);
    if sfilename == 0, return; end;
    SimFullName = [spathname,sfilename];
    com = ['cd ' spathname(1:length(spathname)-1)]; 
    eval(com);
 
 % WAIT SIGN
 SignHndl=uicontrol(jpsth_UI(1),'Style','text','Units','normalized','Position',[.9 .83 .1 0.03],...
	'BackgroundColor','r','ForegroundColor','y',...
        'HorizontalAlignment','center','String','WAIT');
 drawnow
 set(gcf,'Pointer','Watch')
 
   [fid,message] = fopen(SimFullName,'rb');
   if fid<0, 
       error(message);
   end;

 

  set(jpsth_UI(in1+4),'string',['Cell ',num2str(in1),': ',sfilename],'foregroundcolor','b');

  
  [F,lgn] = fread(fid,inf,'char');
  status = fseek(fid,0,-1);  % rewind the file
  ind=0;
  Spk = [];
  spikes=[];
  spikes_length=0;

  %%%%%%%%%%%%%%%%%%%%%%%%%%%% 
  % CELL... vector format (SIM):
  % in each row one segment:
  % #trial
  % #spikes
  % to
  % tend
  % modality
  % spikes arrival times 
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%

  segnum=1;
  while(ind<lgn)
% spikes number, start stim and end stim reading...
	 vect=[];
	 vect(1:5) = fread(fid,5,'float');
         spikes(1:5)=vect(1:5);

% spikes arrival times reading...
	 vect(6:(vect(2)+5)) = fread(fid,vect(2),'float');
         	spikes(6:(vect(2)+5))=vect(6:(vect(2)+5));

	 ncol = size(Spk,2);
	 nrow = size(Spk,1);                %=TrialsNum of the given file
	 vlgn = length(vect);
        
	 maxncol = max((vlgn),ncol);
	 newrow = nrow + 1;
	 tmp = zeros(newrow,maxncol);
	 for i=1:nrow,
	   tmp(i,1:ncol) =Spk(i,:);
	 end;
	 tmp(newrow,1:vlgn) = vect;
         Spk = tmp;
	 ind=ftell(fid);
   end;
   fclose(fid);
   
   SegmentLength =  Spk(:,4) - Spk(:,3);
   if sum(diff(SegmentLength)),
      jpsth('errormessage','Segments of Different Lengths', 'Warning');
   end;       
  
      %set(jpsth_UI(14),'String','0');
      %set(jpsth_UI(17),'String',num2str(min(SegmentLength)));
      DefValues=get(0,'Userdata');
      DefValues(8)=min(SegmentLength);
      set(0,'Userdata',DefValues);
      
      
    % Files Info Info Info Info Info Info Info 
    
    Fig1=jpsth_UI(1);
      
    uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 0.8-in1/4 .2 .09],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor',[.4 .2 .15],...
   'HorizontalAlignment','left','String',['CELL',num2str(in1),':']);

	 uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 0.75-in1/4 .2 .09],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor',[.4 .2 .15],...
   'HorizontalAlignment','left','String',['events #: ',num2str(sum(Spk(:,2)))]);

    uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 0.70-in1/4 .2 .09],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor',[.4 .2 .15],...
   'HorizontalAlignment','left','String',['segments #: ',num2str(size(Spk,1))]);

    uicontrol(Fig1,'Style','text','Units','normalized','Position',[.05 0.65-in1/4 .3 .09],...
	'BackgroundColor',[.7 .7 .8],'ForegroundColor',[.4 .2 .15],...
   'HorizontalAlignment','left','String',['segments duration: ',num2str(sum(Spk(1,4)-Spk(1,3))),' ms']);

     
   out1 = Spk;       % -> to CELL...

  % READY SIGN
  set(SignHndl,'BackgroundColor','g','ForegroundColor',[.1 .1 .1],'String','READY');
  set(gcf,'Pointer','Arrow')

% end of 'read_sim_file'
%---------------------------------------------------------------------------------- 
   elseif(strcmp(action,'errormessage'))
     f = figure('Backingstore','off','Units','norm','position',[.2 .45 .6 .1],'menubar','none','name',in2,...
           'color',[.6 .7 .8],'NumberTitle','off','UserData',0);
     u1 = uicontrol('Units','norm','style','pushbutton','position',...
                  [.4 .1 .2 .35],'string','OK','UserData',1);   

     set(text,'Position',[.05, .7],'units','norm','string',in1,'color','w','fontsize',12)
     set(gca,'visible','off','position',[0 0 1 1])
     waitforbuttonpress;
     delete(gcf);
%---------------------------------------------------------------------------------- 
   elseif(strcmp(action,'message'))
     f = figure('Backingstore','off','Units','norm','position',[.2 .45 .6 .1],'menubar','none','name',in2,...
           'color',[.3 .7 .8],'NumberTitle','off','UserData',0);
     u1 = uicontrol('Units','norm','style','pushbutton','position',...
                  [.4 .1 .2 .35],'string','OK','UserData',1);   

     set(text,'Position',[.05, .7],'units','norm','string',in1,'color','w','fontsize',12)
     set(gca,'visible','off','position',[0 0 1 1])
     waitforbuttonpress;
     delete(gcf);

%---------------------------------------------------------------------------------------
%////////////////////////////////////////////////////////////////
%---------------------------------------------------------------- 
elseif(strcmp(action,'New Analysis')),
   if ~(jpsth('isfigure',jpsth_UI(2))),    
       Fig2 = figure('Backingstore','off','Name','New Analysis','Color','w',...
		 'Units','Normal','Position',[.30 .35 .4 .5],'Resize','Off', 'Menubar','none','Number','off');
       set(gcf,'Pointer','Watch');
	    jpsth_UI(2) = Fig2;	     
    else,
      
       set(0,'CurrentFigure',jpsth_UI(2)); 
       Fig2=jpsth_UI(2);
   end;

  uicontrol(Fig2,'Style','frame','Units','normalized','Position',[.09 .5 .5 .35],...
	'BackgroundColor','w',...
   'ForegroundColor','k');
    
  uicontrol(Fig2,'Style','text','Units','normal','Position',[.17 .8 .33 .08],...
	'ForegroundColor',[.2 .3 .3],...
	'BackgroundColor','w','String','Analysis Type','HorizontalAlignment','center');

  
 

   AnalTypeMenu=uicontrol(Fig2,'Style','popup','Units','normalized','Position',[.15 .75 .375 .04],...
	'BackgroundColor','w','ForegroundColor','k',...
	'HorizontalAlignment','left','value',DefValues(11), 'String',...	
   'Scatter|Raw JPSTH|Pred JPSTH|Norm JPSTH|Coincidence Hist|CrossCor|AutoCorr|PSTH|ISI|Full Analysis|PSTH per sweep|Xcor|Dij|SDij|Xcor-Shift');
   
   jpsth_UI(17)=AnalTypeMenu;
   
   % type of analysis
   AnType=get(AnalTypeMenu,'value');
   
   SetParamBttn=uicontrol(Fig2,'Style','pushbutton','Units','Normalized','Position',[.09 .2 .5 .12],...
   'UserData',AnalTypeMenu,'String','Analysis Parameters');
   SetCallStr = ['AnalTypeHandler = get(gco,''Userdata'');value = get(AnalTypeHandler,''value'');',...
         'jpsth(''SetAnalParam'',value);'];
   set(SetParamBttn,'callback',SetCallStr);     
  

   % GO!!!
   OK_button=uicontrol(Fig2,'Style','pushbutton','Units','Normalized','Position',[.75 .83 .22 .12],...
      'String','OK','UserData',AnalTypeMenu);
   OkCallStr = ['drawnow;AnalTypeHandler = get(gco,''Userdata'');value = get(AnalTypeHandler,''value'');',...
         'usdata=get(0,''Userdata'');usdata(11)=value;set(0,''Userdata'',usdata);delete(',num2str(Fig2), '),set(gcf,''Pointer'',''Watch'');',...
         'jpsth(''Run Analysis'',value);'];
   set(OK_button,'callback',OkCallStr);
      

  cancel=uicontrol(Fig2,'Style','pushbutton','Units','Normalized','Position',[.75 .65 .22 .12],...
	'String','Cancel','Callback',['delete(',num2str(Fig2), '), return']);


     set(gcf,'Pointer','Arrow');
     set(jpsth_UI(1),'Pointer','Arrow');
     
     % The following code intended to enable response to "press any key" (07.05.98)
     %status  = waitforbuttonpress;
     %if status == 1,
     %     drawnow;AnalTypeHandler = get(OK_button,'Userdata');value = get(AnalTypeHandler,'value');
     %     usdata=get(0,'Userdata');usdata(11)=value;set(0,'Userdata',usdata);delete(Fig2),set(gcf,'Pointer','Watch');
     %     jpsth('Run Analysis',value);
     %else 
     %     if gco==AnalTypeMenu
     %        set(gco,'Selected','on');
     %     else
     %        s=get(gco,'Callback');
     %        eval(s);
     %     end
     %end

%-----------------------------------------------------------------------------------------
elseif(strcmp(action,'SetAnalParam')),
   if ~(jpsth('isfigure',jpsth_UIF(1))),
       Fig3 = figure('Backingstore','off','Name',[deblank(Analysis(in1,:)) ' Parameters'],'Color','w',...
		 'Units','Normal','Position',[.2 .2 .6 .4],'Resize','Off', 'Menubar','none','Number','off');
       set(gcf,'Pointer','Watch');
	    jpsth_UIF(1) = Fig3;	     
   else,
       set(0,'CurrentFigure',jpsth_UIF(1)); 
       Fig3=jpsth_UIF(1);
   end;
   
   
   % Setting Parameters

   uicontrol(Fig3,'Style','frame','Units','normalized','Position',[.02 .75 .6 .2],...
	'BackgroundColor','w','ForegroundColor','k');
   % Bin 
    uicontrol(Fig3,'Style','text','Units','normalized','Position',[.05 .8 .2 .09],...
	'BackgroundColor','w','ForegroundColor',[.2 .3 .3],...
	'HorizontalAlignment','left','String','Bin size (ms)');

   jpsth_UI(8)=uicontrol(Fig3,'Style','edit','Units','normalized','Position',[.20 .8 .1 .09],...
	'BackgroundColor','w','ForegroundColor','k',...
	'HorizontalAlignment','left','string',num2str(DefValues(1)));
    
    uicontrol(Fig3,'Style','frame','Units','normalized','Position',[.02 .54 .65 .2],...
	'BackgroundColor','w','ForegroundColor','k');
    % To
    uicontrol(Fig3,'Style','text','Units','normalized','Position',[.05 .59 .2 .09],...
	'BackgroundColor','w','ForegroundColor',[.2 .3 .3],...
	'HorizontalAlignment','left','String','To');
	
        
    jpsth_UI(9) = uicontrol(Fig3,'Style','edit','Units','normalized','Position',[.10 .59 .1 .09],...
	'BackgroundColor','w','ForegroundColor','k',...
	'HorizontalAlignment','left','string',num2str(DefValues(7)));

    % Tn	
    uicontrol(Fig3,'Style','text','Units','normalized','Position',[.25 .59 .2 .09],...
	'BackgroundColor','w','ForegroundColor',[.2 .3 .3],...
	'HorizontalAlignment','left','String','Tn');
   
    jpsth_UI(10) = uicontrol(Fig3,'Style','edit','Units','normalized','Position',[.30 .59 .1 .09],...
	'BackgroundColor','w','ForegroundColor','k',...
   'HorizontalAlignment','left','string',num2str(DefValues(8)));

    % BasicBin Name
    uicontrol(Fig3,'Style','text','Units','normalized','Position',[.46 .59 .1 .09],...
	'BackgroundColor','w','ForegroundColor',[.15 .1 .2],...
	'HorizontalAlignment','left','String','Basic Bin');

    % BasicBin
    jpsth_UI(20) = uicontrol(Fig3,'Style','edit','Units','normalized','Position',[.57 .59 .07 .09],...
	'BackgroundColor','w','ForegroundColor',[.2 .4 .5] ,...
   'HorizontalAlignment','left','string',num2str(DefValues(13)));


    % Shift Predictor
    jpsth_UI(11)=uicontrol(Fig3,'Style','checkbox','Units','normalized','Position',[.05 .40 .3 .09],...
	'BackgroundColor','w','ForegroundColor','b',...
	'HorizontalAlignment','left','String','Shift predictor','value',DefValues(6));
    % Smoothing
    jpsth_UI(12) = uicontrol(Fig3,'Style','checkbox','Units','normalized','Position',[.05 .3 .3 .09],...
	'BackgroundColor','w','ForegroundColor','b',...
	'HorizontalAlignment','left','String','Smoothing','value',DefValues(4));

    uicontrol(Fig3,'Style','text','Units','normalized','Position',[.05 .09 .2 .09],...
	'BackgroundColor','w','ForegroundColor',[.1 .1 .3],...
	'HorizontalAlignment','left','String','Colormap');
    % Color Map 
    jpsth_UI(13)=uicontrol(Fig3,'Style','popup','Units','normalized','Position',[.20 .09 .2 .09],...
	'BackgroundColor','w','ForegroundColor','k',...
	'HorizontalAlignment','left','value',DefValues(5), 'String',...	
   'default|jet|hsv|gray|hot|cool|bone|copper|pink|prism|jet|flag');

   % Normalize
    jpsth_UI(15)=uicontrol(Fig3,'Style','checkbox','Units','normalized','Position',[.05 .2 .4 .09],...
	'BackgroundColor','w','ForegroundColor','b',...
   'HorizontalAlignment','left','String','Normalize','value',DefValues(10));

   % Promt when #events per bin per sweep > 1 
     jpsth_UI(16)=uicontrol(Fig3,'Style','checkbox','Units','normalized','Position',[.5 .2 .35 .09],...
	'BackgroundColor','w','ForegroundColor',[.5 .3 .4],...
   'HorizontalAlignment','left','String','Promt if # events per bin > 1',...
   'value',DefValues(2));

   % for CH - # of bins to take about diagonal

   if in1==5
      modeCH='on';
   else
      modeCH='off';
   end

   jpsth_UI(18)=uicontrol(Fig3,'Style','edit','Units','normalized','Position',[.48 .8 .07 .09],...
	'BackgroundColor','w','ForegroundColor','k',...
	'HorizontalAlignment','left','Enable',modeCH,'string',num2str(DefValues(12)));

   uicontrol(Fig3,'Style','text','Units','normalized','Position',[.35 .8 .12 .1],...
	'BackgroundColor','w','ForegroundColor',[.2 .3 .3],...
	'HorizontalAlignment','left','String','diag. time window','Enable',modeCH);



   jpsth_UI(19)=uicontrol(Fig3,'Style','checkbox','Units','normalized','Position',[.5 .3 .3 .09],...
	'BackgroundColor','w','ForegroundColor',[.2 .2 .7],...
        'HorizontalAlignment','left','String','Show raw with smoothed',...
        'value',DefValues(3),'Enable',modeCH);


   
   if in1==5 | in1==6
      mode='on';
   else
      mode='off';
   end
   
   

    uicontrol(Fig3,'Style','text','Units','normalized','Position',[.5 .09 .2 .09],...
	'BackgroundColor','w','ForegroundColor',[.1 .1 .3],...
	'HorizontalAlignment','left','String','Matrix to analyze...','Enable',mode);

    
    % On which matrix make analysis?
    jpsth_UI(14)=uicontrol(Fig3,'Style','popup','Units','normalized','Position',[.7 .09 .2 .09],...
	'BackgroundColor','w','ForegroundColor','k',...
	'HorizontalAlignment','left','Enable',mode,'value',DefValues(9), 'String',...	
        'Raw|Predictor|Normalized');
   
    
    % Sigma
    if in1==5 | in1==6
       SigmaMode='on';
    else
       SigmaMode='off';
    end
    
    
    uicontrol(Fig3,'Style','text','Units','normalized','Position',[.82 .282 .08 .09],...
	'BackgroundColor','w','ForegroundColor',[.15 .5 .2],...
	'HorizontalAlignment','left','String','Sigma','Enable',SigmaMode);

    
    jpsth_UI(21) = uicontrol(Fig3,'Style','edit','Units','normalized','Position',[.9 .3 .07 .09],...
	'BackgroundColor','w','ForegroundColor','k',...
	'HorizontalAlignment','left','string',num2str(DefValues(14)),'Enable',SigmaMode);

    if in1 == 12 | in1 == 15		% Xcor
	    mode = 'on';
    else
	    mode = 'off';
    end
    
       uicontrol(Fig3,'Style','text','Units','normalized','Position',[.5 .40 .1 .09],...
	'BackgroundColor','w','ForegroundColor',[.15 .5 .72],...
	'HorizontalAlignment','left','String','XCor Bin','Enable',mode);

       jpsth_UI(22)=uicontrol(Fig3,'Style','edit','Units','normalized','Position',[.6 .40 .07 .09],...
	'BackgroundColor','w','ForegroundColor',[ 0.5020 0 0.5020],...
	'HorizontalAlignment','left','String',num2str(DefValues(15)),'Enable',mode);

       uicontrol(Fig3,'Style','text','Units','normalized','Position',[.7 .40 .1 .09],...
	'BackgroundColor','w','ForegroundColor',[.15 .5 .72],...
	'HorizontalAlignment','left','String','Max Lag','Enable',mode);

       jpsth_UI(23)=uicontrol(Fig3,'Style','edit','Units','normalized','Position',[.8 .40 .1 .09],...
	'BackgroundColor','w','ForegroundColor',[ 0.5020 0.4 0.5020],...
	'HorizontalAlignment','left','String',num2str(DefValues(16)),'Enable',mode);


      


    %%%% END OF SETTINGS


   
   OK_button=uicontrol(Fig3,'Style','pushbutton','Units','Normalized','Position',[.75 .83 .22 .12],...
	'String','OK','Callback','jpsth(''update param'');');

   cancel=uicontrol(Fig3,'Style','pushbutton','Units','Normalized','Position',[.75 .65 .22 .12],...
	'String','Cancel','Callback',['delete(',num2str(Fig3), '), return']);


     set(gcf,'Pointer','Arrow');
     set(jpsth_UI(1),'Pointer','Arrow');

%---------------------------------------------------------------------------------------------
 
elseif(strcmp(action,'update param')),
   
   
  set(gcf,'Pointer','Watch');

   
  % User Data:
  %BinSize 1   
  %Xhist   2
  %Yhist   3  
  %Smooth  4  
  %Colmap  5 
  %ShiftPred 6
  %To 7
  %Tend 8
  %BasicM 9
  %Norm 10
  %AnType 11
  %NumParaBin 12
  %BasicBin 13
  %Sigma 14
  %XCorBin 15
  %MaxLag 16
  
  NewParam(1)=  str2num( get(jpsth_UI(8),'string') );
  NewParam(2) = get(jpsth_UI(16),'value');
  NewParam(3) = get(jpsth_UI(19),'value');
  NewParam(4)=  get(jpsth_UI(12),'value');
  NewParam(5)=  get(jpsth_UI(13),'value'); 
  NewParam(6)=  get(jpsth_UI(11),'value');
  NewParam(7)=  str2num( get(jpsth_UI(9),'string') ); 
  NewParam(8)=  str2num( get(jpsth_UI(10),'string') );
  NewParam(9)=  get(jpsth_UI(14),'value');
  NewParam(10)= get(jpsth_UI(15),'value');
  NewParam(11)= DefValues(11);
  NewParam(12)= str2num( get(jpsth_UI(18),'string') );
  NewParam(13)= str2num( get(jpsth_UI(20),'string') );
  NewParam(14)= str2num( get(jpsth_UI(21),'string') );
  NewParam(15)= str2num( get(jpsth_UI(22),'string') ); 
  NewParam(16)= str2num( get(jpsth_UI(23),'string') ); 
  
  set(0,'Userdata',NewParam);
  delete(jpsth_UIF(1));
  watchoff; 

  %---------------------------------------------------------------------------------------
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %---------------------------------------------------------------------------------------
   elseif(strcmp(action,'Run Analysis')),
  

      % WAIT SIGN on main figure
      SignHndl=uicontrol(jpsth_UI(1),'Style','text','Units','normalized','Position',[.9 .83 .1 0.03],...
	'BackgroundColor','r','ForegroundColor','y',...
        'HorizontalAlignment','center','String','WAIT');
      drawnow
      set(jpsth_UI(1),'Pointer','Watch');

      figcounter = figcounter + 1; % update fig counter
      
      %%% color={'default' 'jet' 'hsv' 'gray' 'hot' 'cool' 'bone' 'copper' 'pink' 'prism' 'jet' 'flag'};
      CurFig=figure(figcounter);
      
      set(CurFig ,'Userdata',jpsth_UI(1),'Backingstore','off','Name',[deblank(Analysis(in1,:)),'   ',get(jpsth_UI(5),'string'),'  ',get(jpsth_UI(6),'string')],'Color','w',...
		 'Units','Normal','Position',[.01+figcounter/100 .01+figcounter/100 .60 .70],...
                 'Resize','On', 'Menubar','none','Number','off','Visible','off',...
                 'WindowButtonDownFcn','set(get(gcf,''Userdata''),''Userdata'',gcf);',...
                 'Pointer','Watch');

      PrntHndl=uimenu(CurFig,'Label','&Print Graph');
      uimenu(PrntHndl,'Label','P&rint Setup...','Separator','on','Callback','print -dsetup;');     
      uimenu(PrntHndl,'Label','&Print','Callback','orient portrait; print;');
      uimenu(PrntHndl,'Label','&Save in HGL format As...','Separator','on','Callback','jpsth(''save_hgl'');');      
      uimenu(PrntHndl,'Label','&Save in BMP format As...','Separator','on','Callback','jpsth(''save_bmp'');'); 
      uimenu(PrntHndl,'Label','&Copy to Clipboard as bitmap','Separator','on','Callback','print -dbitmap'); 
      uimenu(PrntHndl,'Label','&Copy to Clipboard as metafile','Separator','on','Callback','print -dmeta'); 

      cellname1=get(jpsth_UI(5),'string');
      cellname2=get(jpsth_UI(6),'string');
    
      %uicontrol(gcf,'style','text','String',[cellname1(8:length(cellname1)),': ',num2str(sum(CELL1(:,2))),cellname2(8:length(cellname2)),': ',num2str(sum(CELL2(:,2)))],'Backgroundcolor','w','ForegroundColor',[.2 .6 .5],'FontSize',8,'Position',[0.001 0.94 0.23 .06]);
      %uicontrol(gcf,'style','frame','String',[cellname1(8:length(cellname1)),cellname2(8:length(cellname2))],'Backgroundcolor','w','ForegroundColor',[.2 .6 .5],'FontSize',8,'Position',[0.001 0.94 0.15 .065]);
      %[0.9961    0.9373    0.8039] 
      %$$$set(h,'ButtonDownFcn','set(gco,''ForegroundColor'',[0.9961    0.9373    0.8039]); set(gco,''ButtonDownFcn'',''set(gco,''''ForegroundColor'''',''''r'''')'')')
      %CurFig = jpsth_UIF(figcounter);
      set(0,'Currentfigure',CurFig);
      
      if in1==1 | in1==2 | in1==3 | in1==4 | in1==13 | in1==14

         set(gca,'drawmode','fast','Position',[.25 .1 .70 .70]);
      else  
         set(gca,'drawmode','fast','Position',[.25 .1 .70 .85]);
            
      end   
      
        
      if (isempty (CELL1)) | (isempty (CELL1)) | (size(CELL1,1) ~= size(CELL2,1) )
          jpsth('errormessage','Different number of segments, or no data files loaded!', 'Warning');
          set(jpsth_UI(1),'Pointer','Arrow')
          jpsth('setsign','ERROR');
          return;
          
      end;
      
      
      if DefValues(6) %%%% Shift predictor
          temp=CELL1(size(CELL1,1),:); % first segment
          for i=size(CELL1,1):-1:2
              CELL1_1(i,:)=CELL1(i-1,:);
          end
          CELL1_1(1,:)=temp;
      else
          CELL1_1=CELL1;
      end
      
      
    BeginningTime 	= DefValues(7);
    EndTime		= DefValues(8);
 
    if EndTime==0
       EndTime=500;
    end
  
    Bin		      	= DefValues(1); 
    Dim                 = round((EndTime-BeginningTime)/Bin);
    BasicBin            = DefValues(13);
    
    if in1==2
          Scatter       = sparse(EndTime-BeginningTime, EndTime-BeginningTime);
    end
    
    PSHBins          = Bin/2:Bin:Dim*Bin-Bin/2;
    PSHBins1ms       = BasicBin/2:BasicBin:EndTime-BeginningTime-BasicBin/2;
    
    SegNum =  size(CELL1,1); %%% Number of rows

    TotalArrTime1=[];
    TotalArrTime2=[]; 
    TotalISI1=[];
    TotalISI2=[];
    XCOR=0;
    CONFLIMS=[0 0 0 0];  % Lower Conf. Lim., Upper Cpnf. Lim., Mean Rate of second train, #trigger events  

    if in1==3 | in1==4 | in1==13 | in1==14 % Predicted JPSTH (npij) or Normalized JPSTH
       if isempty(Scatter) | Scatter==0 | ~exist('Scatter')
          jpsth('errormessage','Please run analysis for raw JPSTH first!','Message');
          jpsth('setsign','ERROR')
          set(jpsth_UI(1),'Pointer','Arrow')
          return
       end
    end
    
   %-----------------------------------------------------------------
   Emp = 0;
   for k=1:SegNum,
    % Read CELL1_1, CELL2
	 TrialNum1	 = CELL1_1(k,1);
    	 SpikesNum1      = CELL1_1(k,2);
	 StartSpikeData1 = CELL1_1(k,3);	
	 EndSpikeData1   = CELL1_1(k,4);
	 SpikeArrTime1   = CELL1_1(k,(6:SpikesNum1+5)) - StartSpikeData1;
 
	 TrialNum2       = CELL2(k,1);
    	 SpikesNum2	 = CELL2(k,2);
	 StartSpikeData2 = CELL2(k,3);
    	 EndSpikeData2 	 = CELL2(k,4);
         SpikeArrTime2   = CELL2(k,(6:SpikesNum2+5)) - StartSpikeData2;
    %- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    

    SpikeArrTime1_ind = find((SpikeArrTime1 >=  BeginningTime) & (SpikeArrTime1 <=  EndTime));
    SpikeArrTime2_ind = find((SpikeArrTime2 >=  BeginningTime) & (SpikeArrTime2 <=  EndTime));

    SpikeArrTime1    = SpikeArrTime1(SpikeArrTime1_ind);
    SpikeArrTime2    = SpikeArrTime2(SpikeArrTime2_ind);
    SpikeArrTimeAbs1 = SpikeArrTime1 - BeginningTime;
    SpikeArrTimeAbs2 = SpikeArrTime2 - BeginningTime;

   
    % for PSH -----------------------------------
    if in1==8
       TotalArrTime1=[TotalArrTime1, SpikeArrTime1];
       TotalArrTime2=[TotalArrTime2, SpikeArrTime2];
    end;
    %--------------------------------------------
    
    % for ISI------------------------------------
    if in1==9
       TotalISI1=[TotalISI1,  diff(SpikeArrTime1)];
       TotalISI2=[TotalISI2,  diff(SpikeArrTime2)];
    end;
    %--------------------------------------------

    if in1==12 % XCOR 

       % for xcor       
       [xc, p] = xcor(SpikeArrTime1,SpikeArrTime2,BeginningTime,EndTime,DefValues(15),DefValues(16));
   
       if ~isempty(xc),
                 
	       XCOR = XCOR +xc(:,2);
               timeaxis = xc(:,1);
       	       CONFLIMS =CONFLIMS+p; % Confidence limits and mean rate of second train      
       else

         Emp = Emp+1;
       end; 
    end
          
    % Calculate ni(k)u, nj(k)v for each segment (for Aertsen et al. analysis or for PSH)
    if (in1==2 | in1==3 | in1==4 | in1==11 | in1==13 | in1==14)
       
      if isempty(SpikeArrTime1)
        niku(k,:) = zeros(1,length(PSHBins));
      else  
        niku(k,:)=hist(round(SpikeArrTime1),PSHBins);
      end
      if isempty(SpikeArrTime2)
        njkv(k,:) = zeros(1,length(PSHBins));
      else
        njkv(k,:)=hist(round(SpikeArrTime2),PSHBins);
      end
    end
    if in1==2 | in1==3 | in1==4 | in1==13 | in1==14 % for normalizaton
       if isempty(SpikeArrTime1)
         niku1ms(k,:) = zeros(1,length(PSHBins1ms));
       else  
         niku1ms(k,:)=hist(round(SpikeArrTime1),PSHBins1ms);
       end
       if isempty(SpikeArrTime2)
          njkv1ms(k,:) = zeros(1,length(PSHBins1ms));
       else
          njkv1ms(k,:)=hist(round(SpikeArrTime2),PSHBins1ms);
       end
    end
    %------------------------------------------------------------------------
    
    % check max number of events per bin per sweep (trial, (inter)stimulus period, segment)
    %=====================================================================================
    if (in1==2 | in1==3 | in1==4 | in1==11) & DefValues(2) % promt
          maxnperbin=max([max(niku(k,:)), max(njkv(k,:))]);
          if maxnperbin>1
             jpsth('message',['The max # of events per bin per sweep exceeds 1 (',num2str(maxnperbin),')'],['sweep # ',num2str(k)]);
          end;
       
    end;
    %============================================================================================================
    

    % Calculate JPSTH ---------------------------------------------------------------------------------
    %for row = 1:Dim,
    %	  for col = 1:Dim,
    %          Matrix(Dim-row+1,col)=length(find((SpikeArrTime1>Bin*(col-1))&(SpikeArrTime1<=Bin*col))) ...
    %          * length(find((SpikeArrTime2>Bin*(row-1))&(SpikeArrTime2<=Bin*row)));
    %    end;
    %end;
    %JPSTHist=JPSTHist + Matrix;
   %--------------------------------------------------------------------------------------------------
   
	SpikesNum1 = length(SpikeArrTime1);
        SpikesNum2 = length(SpikeArrTime2);
   
   if in1==1 % Scatter
      
        % PLOT  Scatter
   	  for i=1:SpikesNum2, 
    	      h=plot(SpikeArrTime1,ones(1,SpikesNum1)*SpikeArrTime2(i),'k.');hold on,
              set(h,'MarkerSize',[1]); 
   	  end;
        axis ([BeginningTime EndTime BeginningTime EndTime])        
        if k==SegNum
           xlabel(['CELL #1'])
           ylabel(['CELL #2'])
           if DefValues(6) % Shift Predictor
             uicontrol(gcf,'style','text','string',['Shift Predictor'],...
             'Position',[.001 0.8 0.15 0.05],'BackgroundColor','w','ForegroundColor','r');
           end
        end
    
   end % of if for Scatter 
     
   if in1==11 % PLOT PSH per sweep
      
      
      %set(gca,'FontSize',8,'XTickLabels',[],'drawmode','fast')
      subplot(SegNum,2,2*k-1)
      bar(niku(k,:))
      axis([0 length(PSHBins) 0 max(niku(k,:))+1])
      ylabel(['#',num2str(k)]);
      
      if k==SegNum
         set(gca,'FontSize',8);
         set(gca,'XTickLabels',get(gca,'XTick'));
      else 
         set(gca,'FontSize',8,'XTickLabels',[],'drawmode','fast')
      end

      
      %set(gca,'FontSize',8,'XTickLabels',[],'drawmode','fast')
      subplot(SegNum,2,2*k)
      bar(njkv(k,:))
      axis([0 length(PSHBins) 0 max(njkv(k,:))+1])
      
      
      if k==SegNum % finish analysis and plot graph
         if k>5
            set(CurFig,'Position',[.01+figcounter/50 .05 .6 .85]);
         end
         set(gca,'FontSize',8);
         set(gca,'XTickLabels',get(gca,'XTick'));
         set(CurFig,'Pointer','Arrow','Visible','on','color',[.49 .52 .62]);
         uicontrol(gcf,'style','text','string',['#bins: ',num2str(Dim),'; PSTH interval: ',num2str(EndTime-BeginningTime),'ms'],...
            'Position',[.2 0.94 0.6 0.05],'BackgroundColor',[.49 .52 .62],'ForegroundColor','r');

         % Make "End of analysis" actions:
         set(CurFig,'Pointer','Arrow','Visible','on');
         set(jpsth_UI(1),'Pointer','Arrow');
         % READY SIGN on main figure
         set(SignHndl,'BackgroundColor','g','ForegroundColor',[.1 .1 .1],'String','READY');

         return

      else 
         set(gca,'FontSize',8,'XTickLabels',[],'drawmode','fast')
      end
   end
        
            

 %========================================
             
            
       
 %see program acd1 for summing diagonal Matrix (for A-corr. estimation) (Sasha's comment)

 end;	% for k... (segments)
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


 if in1==2 % Raw JPSTH
    
    % CALCULATE Scatter analytically:

    % ncij=1/SegNum*(niku1ms'*njkv1ms);
    Scatter=(niku1ms'*njkv1ms);
    JPSTHist=jpsth('apply binning on',Scatter,SegNum);
    
    % PLOT JPSTH
     if DefValues(10) % Normalize
       jpsth('2Dimage',rot90(JPSTHist)/SegNum);
     else 
       jpsth('2Dimage',rot90(JPSTHist));
     end
    
   
    
elseif in1==3 | in1==4 | in1==13 | in1==14 % Predicted JPSTH (npij) or Normalized JPSTH
  if isempty(Scatter) | Scatter==0 | ~exist('Scatter')
     jpsth('errormessage','Please run analysis for raw JPSTH first!','Message');
     return
  end
  
     
  if (isempty(npij))|(isempty(Cij))
     
    %  disp('processing ,npij or Cij are empty...')
    %  tic
    
    % PSH to calculate
    %PSHBins = Bin/2:Bin:Dim*Bin-Bin/2;
    %PSH1=hist(TotalArrTime1,PSHBins);
    %PSH2=hist(TotalArrTime2,PSHBins);

    
    % terminology of Aertsen et al. 1989
    niu=(sum(niku1ms))/SegNum;
    njv=(sum(njkv1ms))/SegNum;
    BinNum=length(niu);
   
    % Calculate SDs PSH1, PSH2
    si=zeros(1,BinNum);
    sj=zeros(1,BinNum);
   
    for u=1:BinNum,
      si(u)= (( sum( (niku1ms(:,u)-niu(u)).^2 ) )*1/SegNum);
      v=u; % ;)
      sj(v)= (( sum( (njkv1ms(:,v)-njv(v)).^2 ) )*1/SegNum);
      
    end
    
    

    % Calculate predictor n~ij(u,v) and SD of predictor
    npij=zeros(BinNum,BinNum);
    for u=1:BinNum,
       npij(u,:)=niu(u)*njv;
       sij(u,:)=si(u)*sj;
    end
    sij=sij.^0.5;
    ncij=1/SegNum*(niku1ms'*njkv1ms);
    % toc
  end % of if for calculating ncij
      

 
    %% Raw JPSTHist (normalized):
    %% nij=rot90(rot90(rot90(nijc)));
   
    % Difference
    % Dij=Scatter/SegNum-npij; $$$ 
       
    % Normalized
    % Cij=Dij./(sij+1); $$$
    
           
    %Dij=Scatter/SegNum-npij;
    % Cij=Dij./(sij+eps);
    
    Dij=ncij-npij;
    Cij=Dij./(sij+eps);
       
 
    
    if in1==3
        jpsth('2Dimage',rot90(jpsth('apply binning on',npij,1)));
    elseif in1==4
        jpsth('2Dimage',rot90(jpsth('apply binning on',Cij,1)));
    elseif in1==13
        jpsth('2Dimage',rot90(jpsth('apply binning on',Dij,1)));
    else
        jpsth('2Dimage',rot90(jpsth('apply binning on',sij,1)));
    end

    
elseif in1==5 | in1==6 % Coincidence Histogram or Correlogram
    
   
   if DefValues(9)==1 % Basic Matrix - raw JPSTH
      if isempty(Scatter) | Scatter==0;
         jpsth('errormessage','Please run analysis for raw JPSTH first!','Message');
         jpsth('setsign','ERROR');
         set(jpsth_UI(1),'Pointer','Arrow');
          
         return
      else     
         M=rot90(jpsth('apply binning on',Scatter/SegNum,1));
         mode='raw JPSTH';
      end
   elseif DefValues(9)==2 % - Predictor JPSTH
      if isempty(npij)
         jpsth('errormessage','Please run analysis for predictor JPSTH first!','Message');
         jpsth('setsign','ERROR');
         set(jpsth_UI(1),'Pointer','Arrow');
         %close(gcf)
         return  
      else  
         M=rot90(jpsth('apply binning on',npij,1));
         %M=M+abs(min(min(M))); % shift all values to positive range
         mode='predictor';
      end
   else % - Norm JPSTH
      if isempty(Cij)
         jpsth('errormessage','Please run analysis for normalized JPSTH first!','Message');
         jpsth('setsign','ERROR');
         set(jpsth_UI(1),'Pointer','Arrow');
         %close(gcf)
         return 
      else  
         M=rot90(jpsth('apply binning on',Cij,1));
         %M=M+abs(min(min(M))); % shift all values to positive range
         mode='normalized JPSTH';
      end
   end
   
  if in1==5 %CH
   % Paradiagonal Bins (PSTH Coincindence Histogram (CH))
   % based of JPSTH (NOT raw scatter matrix!!!)
   DiagonalLength=sqrt( 2*((EndTime-BeginningTime)^2) );
   ParaBinNumber=Dim;
   ParaBinWidth=DiagonalLength/ParaBinNumber;
   mlt=DefValues(12); % mlt - how many multiples of sqrt(2) in ParaBinHeight?
   ParaBinHeight=mlt*sqrt(2); %%%% multiple of sqrt(2)
   CH=zeros(1,ParaBinNumber);

   for i = 1:ParaBinNumber,
    if mlt==1 | mlt==2,
     if (i==1)
         CH(1)=M(Dim,1)+mlt*0.25*M(Dim,2)+mlt*0.25*M(Dim-1,1);
        
     elseif (i==ParaBinNumber)
         CH(i)=M(1,Dim)+mlt*0.25*M(2,Dim)+mlt*0.25*M(1,Dim-1);
        
     else
         CH(i)=M(Dim-i+1,i)+mlt*0.25*M(Dim-i+1,i-1)+mlt*0.25*M(Dim-i+1,i+1)+...
            mlt*0.25*M(Dim-i+2,i)+mlt*0.25*M(Dim-i,i);
       if (mlt==2) 
         CH(i)=CH(i)+0.5*M(Dim-i,i-1)+0.5*M(Dim-i+2,i+1);
       end;
     end;
    else % mlt==3
      if (i==1)
         CH(1)=M(Dim,1)+2*0.25*M(Dim,2)+2*0.25*M(Dim-1,1);
         
      elseif (i==ParaBinNumber)
         CH(i)=M(1,Dim)+2*0.25*M(2,Dim)+2*0.25*M(1,Dim-1);
         
      elseif (i==2)
         CH(i)=M(Dim-i+1,i)+2*0.25*M(Dim-i+1,i-1)+2*0.25*M(Dim-i+1,i+1)+...
            2*0.25*M(Dim-i+2,i)+2*0.25*M(Dim-i,i)+1*M(Dim-i,i-1)+1*M(Dim-i+2,i+1)+...
            0.25*M(Dim-i-1,i-1)+0.25*M(Dim-i+2,i+2);
      elseif (i==ParaBinNumber-1)
          CH(i)=M(Dim-i+1,i)+2*0.25*M(Dim-i+1,i-1)+2*0.25*M(Dim-i+1,i+1)+...
            2*0.25*M(Dim-i+2,i)+2*0.25*M(Dim-i,i)+1*M(Dim-i,i-1)+1*M(Dim-i+2,i+1)+...
            0.25*M(Dim-i,i-2)+0.25*M(Dim-i+3,i+1);

      else
         CH(i)=M(Dim-i+1,i)+2*0.25*M(Dim-i+1,i-1)+2*0.25*M(Dim-i+1,i+1)+...
            2*0.25*M(Dim-i+2,i)+2*0.25*M(Dim-i,i)+1*M(Dim-i,i-1)+1*M(Dim-i+2,i+1)+...
            0.25*M(Dim-i-1,i-1)+0.25*M(Dim-i+2,i+2)+...
            0.25*M(Dim-i,i-2)+0.25*M(Dim-i+3,i+1);
      end

    end % of if for mlt 
    
   end; 
  
   % Normalization
   if mlt==1
      CH(1)=CH(1)+.33*CH(1);
      CH(Dim)=CH(Dim)+.33*CH(Dim);
   elseif mlt == 2
      CH(1)=2*CH(1);
      CH(Dim)=2*CH(Dim);
   else % mlt==3
      CH(1)=CH(1)*3;
      CH(Dim)=CH(Dim)*3;
      CH(2)=CH(2)+1/12*CH(2);
      CH(Dim-1)=CH(Dim-1)+1/12*CH(Dim-1);
   end
      
  %Plot Coincidence Histogram 
  
  % Shift all values to positive range:
  %if min(CH) < 0 
  %   CH=CH+abs(min(CH));
  %end
  
  if DefValues(4) % Smoothing
     sigma=DefValues(14);
     smoothed=jpsth('smooth',CH);
     if DefValues(3) % Show Crude as well
      %t=[BeginningTime:(EndTime-BeginningTime)/(Dim-1):EndTime];
     	bar(CH), hold on,
        %	plot([1:(Dim-1)/(length( smoothed(sigma*3:length(smoothed)-sigma*3) )-1 ):Dim],smoothed(sigma*3+1:length(smoothed)-sigma*3+1),'m');
        	plot([1:(Dim-1)/(length( smoothed(2*sigma*3:length(smoothed)-2*sigma*3) )-1 ):Dim],smoothed(2*sigma*3:length(smoothed)-2*sigma*3),'m');

     else
       % plot([0:Dim/(length(smoothed)-1):Dim],smoothed,'k');
         stairs([1:(Dim-1)/(length( smoothed(sigma*3:length(smoothed)-sigma*3) )-1 ):Dim],smoothed(sigma*3+1:length(smoothed)-sigma*3+1));
     end
  uicontrol(gcf,'style','text','string',['sigma=',num2str(DefValues(14))],...
             'Position',[.001 .2 0.1 .2],'BackgroundColor','w','ForegroundColor','g');
    
  else
     bar(CH)
  end
  
  XTicks=get(gca,'XTick');
  set(gca,'XTicklabels',[BeginningTime:(EndTime-BeginningTime)/(length(XTicks)-2):EndTime]);
  line([0 Dim+1],[0 0],'Color','k','LineWidth',1);  
  grid on
  axis([0 Dim+1 min([2*min(CH) 0])  2*max(CH)])
  ylabel(['Coincidence Firing for ',mode])
  xlabel('time, [ms]')
  uicontrol(gcf,'style','text','string',['time axis: ',num2str(EndTime-BeginningTime),' ms , #bins: ',num2str(ParaBinNumber),'; bin heigth: ',num2str(ParaBinHeight)],...
             'Position',[.001 .4 0.1 .2],'BackgroundColor','w','ForegroundColor','b');
  if DefValues(6) % Shift Predictor
             uicontrol(gcf,'style','text','string',['Shift Predictor'],...
             'Position',[.001 0.8 0.15 0.05],'BackgroundColor','w','ForegroundColor','r');
  end
 
          
 else  % Cross Correlation  
   
  % long paradiagonal bins (cross correlogram (CC))
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  LongParaBinNumber=rem(Dim+1,2)*(Dim-1)+rem(Dim,2)*(Dim-2);

  InPos=2;
  if rem(Dim,2) 
     InPos=3;
  end;

  CC=zeros(1,LongParaBinNumber);
  for i=1:floor(LongParaBinNumber/2), % Upper bins
     for col=1:2*i+1, 
        if col == 2*i+1 % last col in LongParaBin
           CC(i)=CC(i) + 0.5*M(1,col); 
        elseif col==2*i % pre-last col in LongParaBin
           CC(i)=CC(i) + M(1,col) + 0.5*M(2,col);
        else % normal triple
           CC(i)=CC(i) + M(InPos+1-col,col)... % <-initial block
         + 0.5*M(InPos+1-col-1,col)...       % <-upper half-block
         + 0.5*M(InPos+1-col+1,col);         % <-lower half-block
        end % of if
     end % of for 
     InPos=InPos+2;
  end

  % Central bin (diagonal)
  i=i+1; % Shift to the central bin 
  for col=1:Dim,
     if col == 1 % first column
        CC(i)=CC(i) + M(Dim,col) + 0.5*M(Dim-1,col);
     elseif col == Dim % last column
        CC(i)=CC(i) + M(1,col) + 0.5*M(2,col);
     else % normal triple
         CC(i)=CC(i) + M(InPos+1-col,col)...  % <-initial block
         + 0.5*M(InPos+1-col-1,col)...       % <-upper half-block
         + 0.5*M(InPos+1-col+1,col);           % <-lower half-block
     end % of if
  end % of for

  %--------------------------------------------------------------
  %% FOR LOWER BINS
  MM=rot90(rot90(M')); % invert matrix relative to diagonal
                       % in order to bring lower triangle 
                       % to the upper triangle place
                    
  CCt=zeros(1,floor(LongParaBinNumber/2)); % temp vector

  InPos=2;
  if rem(Dim,2) 
     InPos=3;
  end;

  for i=1:floor(LongParaBinNumber/2), % Lower bins
     for col=1:2*i+1, 
        if col == 2*i+1 % last col in LongParaBin
           CCt(i)=CCt(i) + 0.5*MM(1,col); 
        elseif col==2*i % pre-last col in LongParaBin
           CCt(i)=CCt(i) + MM(1,col) + 0.5*MM(2,col);
        else % normal triple
           CCt(i)=CCt(i) + MM(InPos+1-col,col)... % <-initial block
          + 0.5*MM(InPos+1-col-1,col)...         % <-upper half-block
          + 0.5*MM(InPos+1-col+1,col);           % <-lower half-block
        end % of if
    end % of for 
    InPos=InPos+2;
  end

  clear MM;
  CC(floor(LongParaBinNumber/2)+2:LongParaBinNumber)=fliplr(CCt);
  clear CCt;

  % Normalization of Long Paradiagonal Bins according to their area
  %----------------------------------------------------------------
  for i=ceil(LongParaBinNumber/2):-1:1,
     if i == ceil(LongParaBinNumber/2)
        Area(i)=2*Dim-1;
        Len=Dim-2;
     else
        Area(i)=2*Len;
        Len=Len-2;
     end;
  end;

  Area=[Area fliplr(Area(1:length(Area)-1))];
  CC=CC./Area;
  
  % Plot CrossCorrelogram
  % Create lag Axis
  Tend=DefValues(8);
  To=DefValues(7);
  lagaxis=-(Tend-To):2*(Tend-To)/(LongParaBinNumber-1):(Tend-To);

  plot(lagaxis,CC)
  line([0 0],[0 (max(CC)+0.1*max(CC))],'Color','r','LineWidth',1);
  line([-(Tend-To) (Tend-To)],[0 0],'Color','r','LineWidth',1);
  grid

  ylabel(['Crosscorrelogram for ',mode])
  xlabel(['Time Lag'])
  uicontrol(gcf,'style','text','string',['bin #: ',num2str(LongParaBinNumber)],...
             'Position',[.001 .04 0.15 .05],'BackgroundColor','w','ForegroundColor','b');
          
  if DefValues(6) % Shift Predictor
             uicontrol(gcf,'style','text','string',['Shift Predictor'],...
             'Position',[.001 0.8 0.15 0.05],'BackgroundColor','w','ForegroundColor','r');
  end


 end % of if for CH or CC 
 
elseif in1==8 %PSTH
   
   % PSH (to plot)
   PSHBins = Bin/2:Bin:Dim*Bin-Bin/2;
   [PSH1,b1]=hist(TotalArrTime1,PSHBins);
   [PSH2,b2]=hist(TotalArrTime2,PSHBins);

    
   % terminology of Aertsen et al. 1989
   niu=PSH1/SegNum;
   njv=PSH2/SegNum;
   BinNum=length(PSH1);
   
   if (DefValues(10))%Normalized
      PSH1=niu;
      PSH2=njv;
   end
   maxy=max([PSH1 PSH2]);
   
   subplot(2,1,2)
   bar(b2 ,PSH2)
   axis([0 EndTime 0 maxy])
   xlabel('time, ms')
   ylabel('Cell #2')

   subplot(2,1,1)
   bar(b1 ,PSH1)
   axis([0 EndTime 0 maxy])
   xlabel('time, ms')
   ylabel('Cell #1')

elseif in1==9 %ISI
   maxint = max([TotalISI1 TotalISI2]);
   Dim    = ceil(maxint/Bin);

   PSHBins = Bin/2:Bin:Dim*Bin-Bin/2;
   ISIH1=hist(TotalISI1,PSHBins);
   ISIH2=hist(TotalISI2,PSHBins);
   maxy=max([ISIH1 ISIH2]);
   
   subplot(2,1,2)
   bar(ISIH2)
   axis([0 size(ISIH1,2)+1 0 maxy])
   xlabel('bins')
   ylabel('Cell #2')
   subplot(2,1,1)
   bar(ISIH1)
   axis([0 size(ISIH1,2)+1 0 maxy])
   xlabel('bins')
   ylabel('Cell #1')

   uicontrol(gcf,'style','text','string',['time axis: ',num2str(maxint),' ms'],...
      'Position',[.001 .01 0.15 .06],'BackgroundColor','w','ForegroundColor','b');

elseif in1==12 %Xcor

   % get bins:
   %xc=xcor(SpikeArrTime1,SpikeArrTime2,BeginningTime,EndTime,1,50);
   
   if DefValues(10) % Normalize
      XCOR = XCOR/(SegNum-Emp);
      CONFLIMS=CONFLIMS/(SegNum-Emp);
   end
   MaxLag=DefValues(16);
   %CONFLIMS(1:2)=CONFLIMS(1:2)/SegNum;
   plot(timeaxis, XCOR, [-MaxLag, MaxLag], [CONFLIMS(1), CONFLIMS(1)],'r',[-MaxLag, MaxLag], [CONFLIMS(2), CONFLIMS(2)],'g',[-MaxLag, MaxLag],[CONFLIMS(3), CONFLIMS(3)],'m--')
   xlabel(['time, [ms]; # triggers ',num2str(CONFLIMS(4)*SegNum),' MR2 ',num2str(CONFLIMS(3))])
   ylabel(['spikes/s']) 
   set(gca,'XTick',[-MaxLag:5*MaxLag/10:MaxLag])
   grid
   if DefValues(6) % Shift Predictor
      uicontrol(gcf,'style','text','string',['Shift Predictor'],...
         'Position',[.001 0.8 0.15 0.05],'BackgroundColor','w','ForegroundColor','r');
   end

out1=[timeaxis, XCOR];

elseif in1==10 % FULL Analysis

elseif in1==15 %  Xcor-Shift Predictor $$$
   MaxLag=DefValues(16);
   tmp10 = DefValues(10);
   tmp6 = DefValues(6);
   DefValues(10)=1;
   DefValues(6)=1; 
   set(0,'UserData',DefValues);
   XCshift=jpsth('Run Analysis',12);
   DefValues(6)=0;
   set(0,'UserData',DefValues);
   XCraw=jpsth('Run Analysis',12);
   XCnorm=XCraw(:,2)-XCshift(:,2);
   figure(figcounter-2);
   plot(XCraw(:,1), XCnorm)
   xlabel('time, [ms]')
   ylabel('spikes/s')
   set(gca,'XTick',[-MaxLag:5*MaxLag/10:MaxLag])
   grid
   uicontrol(gcf,'style','text','string',['XCor-Shift'],...
         'Position',[.001 0.8 0.15 0.05],'BackgroundColor','w','ForegroundColor',[ 0 0.5020 0.7529]);
   DefValues(6)=tmp6;
   DefValues(10)=tmp10;
   set(0,'UserData',DefValues);

end % of analysis select

% SET NAMES AND MUNBER OF SPIKES:

set(0,'CurrentFigure',CurFig);

set(text,'Position',[-0.15 1.04],'Color',[0.5922 0 0.2941],'string',[cellname1(8:length(cellname1)),': ',num2str(sum(CELL1(:,2))),cellname2(8:length(cellname2)),': ',num2str(sum(CELL2(:,2)))],'FontSize',8,'Fontweight','light');   
set(CurFig,'Pointer','Arrow','Visible','on');

set(jpsth_UI(1),'Pointer','Arrow');
% READY SIGN on main figure
set(SignHndl,'BackgroundColor','g','ForegroundColor',[.1 .1 .1],'String','READY');

%-----------------------------------------------------------------------
% END OF ANALYSIS

      
      
      
   

%---------------------------------------------------------------------------------------   
  elseif(strcmp(action,'2Dimage')), 
  
   %temp=reshape(in1,1,(size(in1,1))^2);
   %temp=sort(temp);
   %temp1=diff(temp);
   %indeces=find(temp1);
   %temp2=temp1(indeces);
   %[mindiff,index]=min(temp2);
   
   upper=max(max(in1));
   lower=min(min(in1));
   % CURRENTLY CONSTANT MAP:
   mindiff=(upper-lower)/250;
   
   if isempty(mindiff)| mindiff==0
      
      mindiff=1;
      lower=upper-1;
   end;

   M=1+(in1-lower)/mindiff;

   %while mindiff<(upper-lower)/250; %!!!
   %      temp2(index)=1;
   %      [mindiff,index]=min(temp2);
   %      if mindiff< 0.0001
   %         mindiff=mindiff+0.001;
   %      end
   %end   

   
   %if lower == 0
   % 	M=in1+1;
   % else 
   % 	M=in1;
   % end

   % in case of uniform JPSTH
   if isempty(mindiff)| mindiff==0
      
      mindiff=1;
      lower=upper-1;
   end;
   
   mapcol=0:1/((upper-lower)/mindiff):1;
   map=[mapcol' mapcol' mapcol'];
   colormap(map);
   image(M)
   XTickL=get(gca,'XTickLabels');
   XTick=[1 get(gca,'XTick')];

   xlabel(['beginning time: ',num2str(DefValues(7)),' end time: ',num2str(DefValues(8)),'  bin: ',num2str(DefValues(1)),' ms'])
   ylabel([Analysis(DefValues(11),:)])

   set(gca,'YTick',XTick(1:length(XTick)-1),'YTickLabels',(fliplr(XTickL'))'); 

   %ha = axes('position',[.92 .1 .04 .7],'color','y');
   hc=colorbar;
   set(hc,'YTick',[1:50:251],'YTicklabels',[lower:(upper-lower)/5:upper])
   
   
   uicontrol(gcf,'style','text','string',['max value: ',num2str(upper)],...
             'Position',[.001 .5 0.15 .06],'BackgroundColor','w','ForegroundColor','b');
   uicontrol(gcf,'style','text','string',['min value: ',num2str(lower)],...
             'Position',[.0001 .4 0.15 .06],'BackgroundColor','w','ForegroundColor','b');
       if DefValues(6) % Shift Predictor
             uicontrol(gcf,'style','text','string',['Shift Predictor'],...
             'Position',[.001 0.6 0.15 0.05],'BackgroundColor','w','ForegroundColor','r');
       end

%---------------------------------------------------------------------------------------
elseif strcmp(action,'apply binning on')
   % disp('apply...')
   % tic
   SegNum=in2;
   
   Bin=DefValues(1);
   Dim=(DefValues(8)-DefValues(7))/Bin;
   JPSTH1ms=in1;
   
   
    for u=1:Dim
       for v=1:Dim
          [ind1,ind2]=find(JPSTH1ms(1+Bin*(u-1):Bin*u,1+Bin*(v-1):Bin*v));
          ind1=ind1+(u-1)*Bin;
          ind2=ind2+(v-1)*Bin;
           JPSTH (u,v)=0;
           for t=1:length(ind1)
              JPSTH (u,v)=JPSTH (u,v)+JPSTH1ms(ind1(t),ind2(t));
           end
      
       end
    end
    
    if DefValues(11)==2 | DefValues(11)==3 | DefValues(11)==4 | DefValues(11)==13 | DefValues(11)==14
         % for JPSTH...
          uicontrol(gcf,'style','text','string',['(',num2str(min(min(JPSTH1ms/SegNum))),' : ',num2str(max(max(JPSTH1ms/SegNum))),')'],...
             'Position',[.001 .2 0.15 .1],'HorizontalAlignment','left','BackgroundColor','w','ForegroundColor','m');
    end;
    % toc   
    out1=JPSTH;
       
%---------------------------------------------------------------------------------------
elseif strcmp(action,'save_hgl')
  
  hglname = ['.hgl'];
  

  [filename, pathname] = uiputfile(hglname, 'Save As ... in HGL format', .4, .4);
       if filename == 0, return; 
       end;
  hglname = [pathname,filename];
  com = ['print -dhpgl ', hglname];
  eval(com);
  
%---------------------------------------------------------------------------------------
elseif strcmp(action,'save_bmp')
  
  bmpname = ['.bmp'];
  

  [filename, pathname] = uiputfile(bmpname, 'Save As ... in BMP format', .4, .4);
       if filename == 0, return; 
       end;
  bmpname = [pathname,filename];
  com = ['print -dbmp16m ', bmpname];
  eval(com);
%---------------------------------------------------------------------------------------
   elseif(strcmp(action,'Clear')),
      
      set(jpsth_UI(5),'string','Cell1','ForegroundColor','k');
      set(jpsth_UI(6),'string','Cell2','ForegroundColor','k');
      clear global CELL1 CELL2 JPSTHist npij Cij M sij ;
%---------------------------------------------------------------------- 
      
elseif(strcmp(action,'info')),
   
      if  isempty(CELL1)
                  jpsth('errormessage','Please, read the data files first...', 'he-he-he!');
         
      else
         
            

   if ~(jpsth('isfigure',jpsth_UIF(2))),    
        InfoFig  = figure('Backingstore','on','Color',[.68 .78 .69],...
	      'Units','Normal','Position',[0.01 0.04 .6 .9],'Resize','Off', 'Name',...
	      'Cells Info','MenuBar','none','Number','off',...
		   'DefaultAxesPosition',[0 0 1 1]);
         set(gcf,'Pointer','Watch');
         set(gca,'Visible','off')
	      jpsth_UIF(2) = InfoFig;	     
    else
       set(0,'CurrentFigure',jpsth_UIF(2)); 
       InfoFig=jpsth_UIF(2);
    end;
    
    if in1>1 
       clf
    end
    
      set(gcf,'Pointer','Watch');
      set(gca,'Visible','off')
      OKHndl=uicontrol(InfoFig,'Style','Pushbutton','Units','Normalized','String','OK','Position',[.82  .01 .15 .05],...
         'Callback','delete(gcf);');
      
      
      
      PrntHndl=uimenu(InfoFig,'Label','&Print Info');
      uimenu(PrntHndl,'Label','P&rint Setup...','Separator','on','Callback','print -dsetup;');     
      uimenu(PrntHndl,'Label','&Print','Callback','print;');
      uimenu(PrntHndl,'Label','&Save in HGL format As...','Separator','on','Callback','jpsth(''save_hgl'');');      
      uimenu(PrntHndl,'Label','&Save in BMP format As...','Separator','on','Callback','jpsth(''save_bmp'');'); 
      uimenu(PrntHndl,'Label','&Copy to Clipboard as bitmap','Separator','on','Callback','print -dbitmap'); 
      uimenu(PrntHndl,'Label','&Copy to Clipboard as metafile','Separator','on','Callback','print -dmeta'); 
      

            
        
       set(text,'Position',[.01 .95],'Color','k','string',get(jpsth_UI(5),'string'));
       set(text,'Position',[.01 .9],'Color','k','string',get(jpsth_UI(6),'string'));
       
       % total #events
          set(text,'FontSize',12,'Position',[.36 .95],...
	           'Color',[.4 .2 .15],...
              'String',['# events: ', num2str(sum(CELL1(:,2)))]);
          set(text,'FontSize',12,'Position',[.36 .9],...
	           'Color',[.4 .2 .15],...
              'String',['# events: ', num2str(sum(CELL2(:,2)))]);
           
           CommentsHndl=uicontrol(InfoFig,'Style','edit','Units','normalized','Position',[.6 .81 .39 .18],...
	         'BackgroundColor','w','ForegroundColor','k',...
	         'HorizontalAlignment','left','string','COMMENTS');



       set(text,'Position',[.22 .83 ],'Color','r','string','Segments Info');
       set(text,'Position',[.65 .79 ],'Color',[.5 .2 .6],'string','cell1');
       set(text,'Position',[.83 .79 ],'Color',[.5 .2 .6],'string','cell2');

       set(text,'Position',[.01 .76 ],'Color','b','string','#Segm.');
       set(text,'Position',[.15 .76 ],'Color','b','string','Trial');
       set(text,'Position',[.27 .76 ],'Color','b','string','to');
       set(text,'Position',[.35 .76 ],'Color','b','string','tend');
       set(text,'Position',[.47 .76 ],'Color','b','string','modality');
       
            
       set(text,'Position',[.65 .76 ],'Color','b','string','#spikes      #spikes');
       

  %%%%%%%%%%%%%%%%%%%%%%%%%%%% 
  % CELL... vector format:
  % in each row one segment:
  % #trial
  % #spikes
  % to
  % tend
  % modality
  % spikes arrival times 
  % ...
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
       
       for i=in1:size(CELL1,1),
          set(text,'FontSize',8,'Position',[.05 0.75-(i-in1+1)/50],...
	           'Color',[.2 .5 .2],...
              'String',num2str(i));
          set(text,'FontSize',8,'Position',[.18 0.75-(i-in1+1)/50],... % trial
	           'Color',[.4 .2 .15],...
              'String',[num2str(sum(CELL1(i,1)))]);
          set(text,'FontSize',8,'Position',[.27 0.75-(i-in1+1)/50],... % to
	           'Color',[.4 .2 .15],...
              'String',[num2str(sum(CELL1(i,3)))]);
          set(text,'FontSize',8,'Position',[.35 0.75-(i-in1+1)/50],... %tend
	           'Color',[.4 .2 .15],...
              'String',[num2str(sum(CELL1(i,4)))]);
          set(text,'FontSize',8,'Position',[.5 0.75-(i-in1+1)/50],... % modality
	           'Color',[.4 .2 .15],...
              'String',[num2str(sum(CELL1(i,5)))]);

          set(text,'FontSize',8,'Position',[.7 0.75-(i-in1+1)/50],... %
	           'Color',[.4 .2 .15],...
              'String',[num2str(sum(CELL1(i,2)))]);
          set(text,'FontSize',8,'Position',[.88  0.75-(i-in1+1)/50 ],...
	           'Color',[.4 .2 .15],...
              'String',[num2str(sum(CELL2(i,2)))]);
           
           if i==in1+33 % end of space
               MoreHndl=uicontrol(InfoFig,'Style','Pushbutton','Units','Normalized','String','More...','Position',[.62  .01 .15 .05],...
                  'Userdata',OKHndl);
               set(OKHndl,'Userdata',i);
               MoreStr=['OKHndl=get(gco,''Userdata'');jpsth(''info'',get(OKHndl,''Userdata'')+1);'];
               set(MoreHndl,'Callback',MoreStr);

               set(gcf,'Pointer','Arrow');
               break
           end
      end;    
      
        
      
      
      set(gca,'Visible','Off');
      set(gcf,'Pointer','Arrow');
      end
      % END OF INFO

%---------------------------------------------------------------------------------------
   elseif(strcmp(action,'setsign')),
      % SET SIGN on main figure
      if strcmp(in1,'ERROR')
         FC='r';
         BC='y';
      else 
         FC='w';
         BC='b';
      end

      SignHndl=uicontrol(jpsth_UI(1),'Style','text','Units','normalized','Position',[.9 .83 .1 0.03],...
	'BackgroundColor',BC,'ForegroundColor',FC,...
        'HorizontalAlignment','center','String',in1);
      drawnow
%---------------------------------------------------------------------------------------
   elseif(strcmp(action,'smooth')),
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % see Abeles 1982: Quantification, smoothing, and confidence limits for single-units'
    % histogram. Journal of Neurosci Meth 5:317-325
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    s=DefValues(14); %SIGMA
    t=-3*s:1:3*s;
    %t=DefValues(7):DefValues(1):DefValues(8);
    b=exp(-t.^2/(2*s^2));
    % Normalization 
    tb=(1.003/(2*pi*s)^.5)*b;
    divider=sum(tb);
    in1=[fliplr(in1(1:3*s)) in1 fliplr( in1(length(in1)-3*s:length(in1)))];
    %in1=in1(3*s:length(in1)-3*s);
    
    out1=(1/divider)*(1.003/(2*pi*s)^.5)*conv(in1,b);
    

%------------------------ end of smoothing --------------------------------------------- 

 elseif(strcmp(action,'exit')),
      fclose('all');
      kids = get(0,'Children');
      delete(kids);
%--------------------------------------------------------------------------------------- 

   end; %%% OF if he-he-he


